#ifndef FIELD_H
#define FIELD_H

#include <iostream>
#include <vector>

class CField {

  class CPiece *fields[8][8];
  class CKing *m_pKingWhite, *m_pKingBlack;

  static inline int normalalize(int i);

public:

  CField();
  ~CField();

  void reset();

  friend std::ostream& operator<<(std::ostream &os, const CField &field);

  bool isAttacked(int x, int y, int color);
  void setPiece(int x, int y, class CPiece *pPiece);
  bool move(int fromX, int fromY, int toX, int toY);
  bool intersect(int fromX, int fromY, int toX, int toY, bool includeTarget = false);
  bool checkBounds(int x, int y);

  class CKing *getKingBlack() const { return m_pKingBlack; }
  class CKing *getKingWhite() const { return m_pKingWhite; }
  class CPiece *getPiece(int x, int y) { return fields[x][y]; }
};

#endif
