#ifndef PIECE_H
#define PIECE_H

#include "Game.h"
#include <string>

using namespace std;

class CPiece {

public:

  enum Type {
    PAWN = 0,
    ROOK,
    KNIGHT,
    BISHOP,
    KING,
    QUEEN
  };

private:

  const Type m_Type;
  const string m_Icon;
  const int m_Color;

public:

  bool m_HasMoved;
  int m_X, m_Y;

  CPiece(Type type, string icon, int x, int y, int color) :
    m_Type(type), m_Icon(icon), m_Color(color) {
    m_HasMoved = false;
    m_X = x;
    m_Y = y;
  }

  virtual ~CPiece() { }

  friend std::ostream& operator<<(std::ostream &os, const CPiece &piece) {
    return os << piece.m_Icon;
  }

  Type getType() const { return m_Type; }
  int getColor() const { return m_Color; }
  bool moveTo(class CField *pField, int destX, int destY);

  // Virtual methods
  virtual bool canMove(class CField *pField, int destX, int destY)  = 0;
};

#endif
