#include "Bishop.h"
#include "../Field.h"

CBishop::CBishop(int x, int y, int color)
  : CPiece(Type::BISHOP, (color == Color::WHITE ? "♗" : "♝"), x, y, color) {
}

bool CBishop::canMove(CField *pField, int destX, int destY) {


  int dirX = destX - m_X;
  int dirY = destY - m_Y;

  if(abs(dirX) != abs(dirY))
    return false;

  // check intersection
  if(pField->intersect(m_X, m_Y, destX, destY))
    return false;

  return true;
}
