#include "Pawn.h"
#include "../Field.h"

CPawn::CPawn(int x, int y, int color)
  : CPiece(Type::PAWN, (color == Color::WHITE ? "♙" : "♟"), x, y, color) {
}

bool CPawn::canMove(CField *pField, int destX, int destY) {

  // check for valid movement
  int dirY = destY - m_Y;
  int dirX = destX - m_X;

  // dirY = { -2, -1, 1, 2 }
  // dirX = { -1, 0, 1     }

  // Invalid movement
  if(abs(dirY) > 2 || abs(dirX) > 1 || dirY == 0)
    return false;

  // Check for direction
  if(dirY < 0 && getColor() == Color::WHITE)
    return false;
  else if(dirY > 0 && getColor() == Color::BLACK)   // Check for direction
    return false;

  // Case 1: 2 steps if not moved
  if(abs(dirY) == 2) {
    if(dirX != 0 || m_HasMoved)
      return false;

  // Case 2: 1 Step crosswise
  } else if(abs(dirY) == 1 && dirX != 0) {
      CPiece *targetPiece = pField->getPiece(m_X + dirX, m_Y + dirY);
      if(targetPiece == nullptr)
        return false;

      // TODO: en passant
      // else
  }

  // Todo: check for base line of opponent

  return !pField->intersect(m_X, m_Y, destX, destY, dirX == 0);
}
