#include "Queen.h"
#include "../Field.h"

CQueen::CQueen(int x, int y, int color)
  : CPiece(Type::QUEEN, (color == Color::WHITE ? "♕" : "♛"), x, y, color) {
}

bool CQueen::canMove(CField *pField, int destX, int destY) {

  int dirX = destX - m_X;
  int dirY = destY - m_Y;

  if(abs(dirX) == abs(dirY) || ((m_X == destX) != (m_Y == destY)))
    return !pField->intersect(m_X, m_Y, destX, destY);

  return false;
}
