#include "Rook.h"
#include "../Field.h"

CRook::CRook(int x, int y, int color)
  : CPiece(Type::ROOK, (color == Color::WHITE ? "♖" : "♜"), x, y, color) {
}

bool CRook::canMove(CField *pField, int destX, int destY) {

  // different x or different y but not both different/equal
  if((m_X == destX) == (m_Y == destY))
    return false;

  // check intersection
  if(pField->intersect(m_X, m_Y, destX, destY))
    return false;

  return true;
}
